import bb.cascades 1.0

Container {
    // We use index yet again so we can set the setting as well.
    // the value (dropDown.selectedValue) is read-only.
    //
    // 0: Internal storage
    // 1: SD card
    property alias index: dropDown.selectedIndex
    
    Header {
        title: "Storage Settings"
        subtitle: "Where should I save your downloads?"
    }
    Container {
        horizontalAlignment: HorizontalAlignment.Fill
        leftPadding: 20.0
        rightPadding: 20.0
        topPadding: 20.0
        DropDown {
            id: dropDown
            horizontalAlignment: HorizontalAlignment.Fill
            title: "Download to"

            Option {
                text: "Internal storage"
                //description: "Save downloads to the internal storage of the device."
                //value: "internal"
                
            }

            Option {
                text: "SD card"
                //description: "Save files to the SD card."
                //value: "sdcard"
                
                // This is how you gray it out:
                // enabled: false 
                
                // Once the card is out - we gray this out and select Internal,
                // but we don't lose the setting. Whenever the card comes back
                // we ungrey - restore setting.
            }
        }
    }
    Divider {
        horizontalAlignment: HorizontalAlignment.Fill
    }
}
