import bb.cascades 1.0

Container {
    id: torrentListItem
    // Necessary to use LtR StackLayout here to fill the width.
    layout: StackLayout {
        orientation: LayoutOrientation.LeftToRight
    }
    Container {
        layoutProperties: StackLayoutProperties {
            spaceQuota: 1
        }
        layout: DockLayout {
        }
        // background: Color.Magenta
        Container {
            id: highlightBorder
            background: Color.create("#32b8e4")
            opacity: 0.0
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
        }
        Container {
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            layout: DockLayout {
            }
            leftPadding: 5.0
            rightPadding: 5.0
            bottomPadding: 5.0
            topPadding: 5.0
            Container {
                background: Color.White
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
            }
            Container {
                id: highlightContainer
                background: Color.create("#00a7de")
                opacity: 0.0
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
            }
        }

        // Content
        Container {
            // background: Color.Green
            horizontalAlignment: HorizontalAlignment.Fill
            leftPadding: 20.0
            rightPadding: 20.0
            topPadding: 10.0
            bottomPadding: 10.0

            // Name
            Label {
                text: ListItemData.Name
                //text: "Name"
                textStyle.base: SystemDefaults.TextStyles.TitleText
            }

            // Upper
            Label {
                text: "Downloaded: " + ListItemData.Have + " (" + ListItemData.Done + "%)" + (ListItemData.ETA == "Done" || ListItemData.ETA == "Unknown" || ListItemData.ETA == "Not Avail" ? "" : " - " + ListItemData.ETA + " left")
                //text: "ASD"
                textStyle.base: SystemDefaults.TextStyles.SubtitleText
            }

            // Progress
            ProgressIndicator {
                id: progressbar
                fromValue: 0
                toValue: 100
                value: ListItemData.Done
                state: ListItemData.Status == "Stopped" ? ProgressIndicatorState.Pause : (ListItemData.ETA == "Done" ? ProgressIndicatorState.Complete : ProgressIndicatorState.Progress)
                horizontalAlignment: HorizontalAlignment.Fill
            }

            // Lower
            Label {
                text: ListItemData.Status + (ListItemData.Status.substring(0, "Error".length) == "Error" || ListItemData.Status == "Queued" || ListItemData.Status == "Will Verify" || ListItemData.Status == "Verifying" || ListItemData.Status == "Idle" || ListItemData.Status == "Stopped" ? "" : " - ↓ " + ListItemData.Down + "KB, ↑ " + ListItemData.Up + "KB")
                //text: "Lower"
                textStyle.base: SystemDefaults.TextStyles.SubtitleText
            }
        }
//        Container {
//            id: separatorTop
//            background: Color.Gray
//            preferredHeight: 1
//            horizontalAlignment: HorizontalAlignment.Fill
//            verticalAlignment: VerticalAlignment.Top
//        }
        Container {
            id: separatorBottom
            background: Color.Gray
            preferredHeight: 1
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Bottom
        }
    }

    ListItem.onActivationChanged: {
        if (ListItem.active) {
            highlightBorder.opacity = 1.0;
            highlightContainer.opacity = 0.5;
        } else {
            highlightBorder.opacity = 0.0;
            highlightContainer.opacity = 0.0;
        }
    }

    ListItem.onSelectionChanged: {
        if (ListItem.selected) {
            highlightContainer.opacity = 1.0;
            highlightBorder.opacity = 1.0;
        } else {
            highlightContainer.opacity = 0.0;
            highlightBorder.opacity = 0.0;
        }
    }
}
