import bb.cascades 1.0
import CustomComponent 1.0
import bb.cascades.advertisement 1.0
import bb.system 1.0

NavigationPane {
    id: navPane
    property bool daemonBusy: torrentModel.busy || _app.daemonKilled
    signal torrentOpened()
    
    // Add the application menu using a MenuDefinition
    Menu.definition: MenuDefinition {
        // Specify the actions that should be included in the menu
        settingsAction: SettingsActionItem {
            onTriggered: {
                navPane.push(settingsPage);
            }
        }
        actions: [
            ActionItem {
                title: "About"
                imageSource: "asset:///images/about.png"
                onTriggered: {
                    navPane.push(aboutPage);
                }
            }
        ] // end of actions list
    } // end of MenuDefinition
    onCreationCompleted: {
        console.log("Attempt to connect torrentModel.torrentOpened");
        torrentModel.torrentOpened.connect(torrentOpenedToast.show);
        
        // Is this first run?
        if (_app.firstRun) {
            //if (true) {
            navPane.push(agreementPage);
        } else {
            navPane.push(torrentListPage);
        }
    }

    attachedObjects: [
        Page {
            id: agreementPage
            property bool disagreed: false
            titleBar: TitleBar {
                //kind: TitleBarKind.Default
                title: "Agreement"
                acceptAction: ActionItem {
                    enabled: ! agreementPage.disagreed
                    id: agreeAction
                    title: "I Agree"
                    onTriggered: {
                        //navPane.remove(agreementPage);
                        navPane.push(networkModePage);
                    }
                }
//                dismissAction: ActionItem {
//                    enabled: ! agreementPage.disagreed
//                    title: "I Disagree"
//                    onTriggered: {
//                        agreementPage.disagreed = true;
//                        // Better than before but still not great.
//                        // We have to check whether this is better or maybe show some
//                        // message if the hit Disagree.
//                        Application.requestExit();
//                    }
//                }
            }
            Container {
                leftPadding: 20.0
                rightPadding: 20.0
                //topPadding: 20.0
                //bottomPadding: 20.0
                verticalAlignment: VerticalAlignment.Fill
                horizontalAlignment: HorizontalAlignment.Fill
                ScrollView {
                    id: scrollView
                    verticalAlignment: VerticalAlignment.Fill
                    horizontalAlignment: HorizontalAlignment.Fill
                    scrollViewProperties.scrollMode: ScrollMode.Vertical
                    scrollViewProperties.pinchToZoomEnabled: false
                    Label {
                        //text: "<html><b>Disclaimer of Warranty.</b><br/><p>THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM “AS IS” WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.</p><br/><b>Limitation of Liability.</b><br/><p>IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.</p></html>"
                        multiline: true
                        verticalAlignment: VerticalAlignment.Fill
                        horizontalAlignment: HorizontalAlignment.Fill
                        text: "<html><b>End User License Agreement (EULA)</b>

<p>By accepting this agreement or by installing BitTorque (the \"Software\") and clicking \"I Agree\", you agree to the following terms, notwithstanding anything to the contrary in this agreement.</p>
<p>The Software is a peer-to-peer file sharing application, written by us (the \"Authors\").</p>
<b>License</b>
<p>Subject to your compliance with these terms and conditions, you are granted a royalty-free, non-exclusive, non-transferable license to use the Software, solely for your personal, non-commercial purposes. The Authors reserve all rights in the Software not expressly granted to you here.</p>
<b>Restrictions</b>
<p>The source code, design, and structure of the Software are trade secrets. You will not disassemble, decompile, or reverse engineer it, in whole or in part, except to the extent expressly permitted by law, or distribute it. You will not use the Software for illegal purposes. You will comply with all export laws. The Software is licensed, not sold.</p>
<b>How BitTorque Works</b>
<i>- Downloading and Updates</i>
<p>The Software downloads only those files that are both authorized by you for download (specifically or by category or subscription), except that the Software automatically updates itself.</p>
<i>- Automatic Uploading</i>
<p>The Software accelerates downloads by enabling your device to grab pieces of files from other torrent users simultaneously. Your use of the Software to download files will, in turn, enable other users to download pieces of those files from you, thereby maximizing download speeds for all users. In the Software, only files that you are explicitly downloading or sharing or have downloaded or shared will be made available to others. You consent to other users' use of your network connection to download portions of such files from you. At any time, you may uninstall the Software through Blackberry World (tm). In addition, you can control the Software in multiple ways through its user interface without affecting any files you have already downloaded.</p>
<b>Disclaimer of Warranty</b>
<p>The Authors disclaim any responsibility for harm resulting from the Software or any software or content downloaded using the Software. The entire risk as to the quality and performance of the Software is with you. Should the Software prove defective, you assume the cost of all necessary servicing, repair or correction. The Authors do not guarantee that the Software or downloaded content will function, sound, or appear as offered or hoped, or be complete, accurate, or free from bugs, errors, viruses, or other harmful content. The Authors expressly disclaim all warranties and conditions, express or implied, including any implied warranties and conditions of merchantability, fitness for a particular purpose, and non-infringement, and any warranties and conditions arising out of course of dealing or usage of trade regarding the Software or any software or content you download using the Software. No advice or information, whether oral or written, obtained from us or elsewhere will create any warranty or condition not expressly stated in this agreement. Some jurisdictions do not allow certain limitations on implied warranties, so the above limitation may not apply to you to its full extent.</p>
<b>Limitation of Liability</b>
<p>In no event and under no theory of liability will the Authors be liable to you for any damages, including any general, special, incidental, exemplary, or consequential damages arising out of or in connection with this agreement or arising from the use or inability to use the Software (including but not limited to legal consequences arising from the use of the Software, loss of data, or data being rendered inaccurate, or losses sustained by you or third parties, or a failure of the Software to operate, or to operate with any other programs), whether or not the Authors have been advised of the possibility of such damages. The foregoing limitations will survive even if any limited remedy specified is found to have failed of its essential purpose. Some jurisdictions do not allow the limitation or exclusion of liability for incidental or consequential damages, so the above limitation or exclusion may not apply to you to its full extent.</p>
<b>Government Users</b>
<p>The Software is \"commercial computer software\" any use of which by or on behalf of the government is subject to the restrictions herein.</p>
<b>General</b>
<p>The terms in this license will be governed by and construed in accordance with the laws of Canada without regard to conflicts of law rules. The United Nations Convention on Contracts for the International Sale of Goods will not apply. The failure by either party to enforce any provision will not constitute a waiver. Any waiver, modification, or amendment of these terms will be effective only if signed. If any provision is held to be unenforceable, it will be enforced to the maximum extent possible and will not diminish other provisions. The Authors may make changes to these terms from time to time. You understand and agree that if you use the Software after the date on which the terms have changed, the Authors will treat your use as acceptance of the updated terms. This is our complete and exclusive understanding with you regarding your use of the Software as an end user.</p>
</html>"
                    }
                }
            }
        },
        Page {
            id: networkModePage
            titleBar: TitleBar {
                title: "Network Settings"
                acceptAction: ActionItem {
                    title: "Finish"
                    onTriggered: {
                        _app.firstRun = false;
                        navPane.remove(agreementPage);
                        navPane.remove(networkModePage);
                        navPane.push(torrentListPage);
                    }
                }
            }
            Container {
                //leftPadding: 20.0
                //rightPadding: 20.0
                //topPadding: 20.0
                //bottomPadding: 20.0
                verticalAlignment: VerticalAlignment.Fill
                horizontalAlignment: HorizontalAlignment.Fill
                NetworkModes {
                    horizontalAlignment: HorizontalAlignment.Fill
                    index: _app.networkMode
                    onIndexChanged: {
                        if (index != _app.networkMode) {
                            _app.networkMode = index;
                        }
                    }
                }
            }
        },
        // The main page
        Page {
            id: torrentListPage
            titleBar: TitleBar {
                id: segmentedTitle
                kind: TitleBarKind.Segmented

                // The segmented control decides which filter should be set on the model.
                options: [
                    Option {
                        enabled: ! daemonBusy
                        text: "All"
                        value: "All"
                    },
                    Option {
                        enabled: ! daemonBusy
                        text: "Active"
                        value: "Active"
                    },
                    Option {
                        enabled: ! daemonBusy
                        text: "Finished"
                        value: "Finished"
                    }
                ]
                onSelectedValueChanged: {
                    // When a new Option is selected the dataModel of the ListView, the
                    // filter is set and the list is repopulated.
                    torrentModel.filter = selectedValue;
                }
            }
            //actionBarVisibility: daemonBusy == true ? ChromeVisibility.Hidden : ChromeVisibility.Visible
            Container {
                layout: DockLayout {
                }
                Container {
                    id: mainContainer
                    layout: StackLayout {
                    }
                    attachedObjects: [
                        Banner {
                            id: banner
                            zoneId: 117145
                            refreshRate: 60
                            preferredWidth: 320
                            preferredHeight: 50
                            transitionsEnabled: true
                            placeHolderURL: "asset:///images/placeholder_320x50.png"
                            //backgroundColor: Color.Green
                            //borderColor: Color.Gray
                            borderWidth: 0
                            horizontalAlignment: HorizontalAlignment.Center
                        }
                    ]
                    onCreationCompleted: {
                        if (packageInfo.name == "com.bittorque.app.free") {
                            insert(-1, banner);
                        }
                    }
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                    ListView {
                        id: torrentList
                        property bool torrentModelBusy: daemonBusy
                        //opacity: daemonBusy == false ? 1.0 : 0.1
                        visible: ! daemonBusy
                        enabled: ! daemonBusy
                        function open(id) {
                            torrentModel.open(id);
                            torrentModel.poll();
                        }
                        function start(id) {
                            torrentModel.start(id);
                            torrentModel.poll();
                        }
                        function stop(id) {
                            torrentModel.stop(id);
                            torrentModel.poll();
                        }
                        function remove(id) {
                            torrentModel.remove(id);
                            torrentModel.poll();
                        }
                        function removeAndDelete(id) {
                            torrentModel.removeAndDelete(id);
                            torrentModel.poll();
                        }
                        dataModel: groupModel
                        listItemComponents: [
                            ListItemComponent {
                                type: "item"
                                TorrentListItem {
                                    id: torrentListItem
                                    contextActions: [
                                        // Add actions for the context menu here
                                        ActionSet {
                                            title: ListItemData.Name
                                            InvokeActionItem {
                                                enabled: ListItemData.ETA == "Done" && ! torrentListItem.ListItem.view.torrentModelBusy
                                                // TODO: This has to be reworked to pass file name
                                                // from the model because at the moment we provide
                                                // user-selectable download location, this will break.
                                                query {
                                                    uri: "file:///accounts/1000/shared/downloads/" + ListItemData.Name
                                                }
                                            }
                                            ActionItem {
                                                enabled: ! torrentListItem.ListItem.view.torrentModelBusy
                                                title: "Start"
                                                imageSource: "asset:///images/start.png"

                                                // Disable if downloading.
                                                //enabled: ! torrentModel.started(ListItemData.ID)
                                                onTriggered: {
                                                    torrentListItem.ListItem.view.start(ListItemData.ID);
                                                }
                                            }
                                            ActionItem {
                                                enabled: ! torrentListItem.ListItem.view.torrentModelBusy
                                                title: "Stop"
                                                imageSource: "asset:///images/stop.png"

                                                // Disable if stopped.
                                                //enabled: ! torrentModel.stopped(ListItemData.ID)
                                                onTriggered: {
                                                    torrentListItem.ListItem.view.stop(ListItemData.ID);
                                                }
                                            }
                                            ActionItem {
                                                enabled: ! torrentListItem.ListItem.view.torrentModelBusy
                                                title: "Remove"
                                                imageSource: "asset:///images/remove.png"

                                                // Disable if stopped.
                                                //enabled: ! torrentModel.stopped(ListItemData.ID)
                                                onTriggered: {
                                                    torrentListItem.ListItem.view.remove(ListItemData.ID);
                                                }
                                            }
                                            DeleteActionItem {
                                                enabled: ! torrentListItem.ListItem.view.torrentModelBusy
                                                title: "Remove and Delete"
                                                imageSource: "asset:///images/removeanddelete.png"

                                                // Disable if stopped.
                                                //enabled: ! torrentModel.stopped(ListItemData.ID)
                                                onTriggered: {
                                                    torrentListItem.ListItem.view.removeAndDelete(ListItemData.ID);
                                                }
                                            }
                                        } // end of ActionSet
                                    ]
                                }
                            }
                        ]

                        // React on list item tap.
                        onTriggered: {
                            // Open the downloaded file.
                            var selectedItem = dataModel.data(indexPath);
                            // Attempt to open.
                            //     dirPaths.downloads
                            console.log(selectedItem.torrent_info);
                        }
                    }
                }
                BusyIndicator {
                    id: busyIndicator
                    busy: torrentModel.busy && ! torrentModel.startingDaemon && ! _app.daemonKilled
                    message: "I'm working on something important. If you've recently added a torrent, please wait. I'll be done in a few minutes."
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                }
                BusyIndicator {
                    id: startingIndicator
                    busy: torrentModel.startingDaemon && ! _app.daemonKilled
                    message: "I'm kick-starting the engine."
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                }
                Container {
                    layout: DockLayout {
                    }
                    id: killedIndicator
                    visible: _app.daemonKilled && (_app.networkMode == 2)
                    verticalAlignment: VerticalAlignment.Fill
                    horizontalAlignment: HorizontalAlignment.Fill
                    Container {
                        Label {
                            text: "I've halted the engine because you're in \"Strictly WiFi\" network mode but not connected to WiFi."
                            horizontalAlignment: HorizontalAlignment.Center
                            multiline: true
                            textStyle.textAlign: TextAlign.Center
                        }
                        horizontalAlignment: HorizontalAlignment.Center
                        verticalAlignment: VerticalAlignment.Center
                        Button {
                            text: "Settings"
                            onClicked: {
                                navPane.push(settingsPage);
                            }
                            horizontalAlignment: HorizontalAlignment.Center
                        }
                    }
                }
            }
            actions: [
                ActionItem {
                    // An ActionItem for adding a torrent.
                    enabled: ! daemonBusy
                    title: "Add"
                    imageSource: "asset:///images/add.png"
                    ActionBar.placement: ActionBarPlacement.OnBar
                    onTriggered: {
                        // TODO: Maybe invoke file picker.
                        console.log("Add");
                        filePicker.open();
                    }
                },
                ActionItem {
                    // An ActionItem for pausing all torrents.
                    enabled: ! daemonBusy
                    title: "Start All"
                    imageSource: "asset:///images/start.png"
                    ActionBar.placement: ActionBarPlacement.OnBar

                    // Disable if all active.
                    //enabled: ! torrentModel.allStarted
                    onTriggered: {
                        torrentModel.startAll();
                        torrentModel.poll();
                    }
                },
                ActionItem {
                    // An ActionItem for stopping all torrents.
                    enabled: ! daemonBusy
                    title: "Stop All"
                    imageSource: "asset:///images/stop.png"
                    ActionBar.placement: ActionBarPlacement.OnBar

                    // Disable if all stopped.
                    //enabled: ! torrentModel.allStopped
                    onTriggered: {
                        torrentModel.stopAll();
                        torrentModel.poll();
                    }
                }
            ]
            attachedObjects: [
                FilePicker {
                    id: filePicker
                    type: FileType.Other
                    title: "Select Torrent"
                    filter: [
                        "*.torrent"
                    ]
                    directories: [
                        "/accounts/1000/shared/downloads"
                    ]
                    onFileSelected: {
                        console.log("FileSelected signal received : " + selectedFiles);
                        torrentModel.open(selectedFiles);
                        torrentModel.poll();
                    }
                },
                ComponentDefinition {
                    id: appCover
                    source: "AppCover.qml"
                }
            ]
            onCreationCompleted: {
                Application.cover = appCover.createObject();
            }
        },
        AboutPage {
            id: aboutPage
    
        },
        Page {
            id: settingsPage
            titleBar: TitleBar {
                //kind: TitleBarKind.Default
                title: "Settings"
            }
            ScrollView {
                verticalAlignment: VerticalAlignment.Fill
                horizontalAlignment: HorizontalAlignment.Fill
                scrollViewProperties.scrollMode: ScrollMode.Vertical
                scrollViewProperties.pinchToZoomEnabled: false
                Container {
                    layout: StackLayout {
                    }
                    verticalAlignment: VerticalAlignment.Fill
                    horizontalAlignment: HorizontalAlignment.Fill
                    NetworkModes {
                        horizontalAlignment: HorizontalAlignment.Fill
                        index: _app.networkMode
                        onIndexChanged: {
                            if (index != _app.networkMode) {
                                _app.networkMode = index;
                            }
                        }
                    }
                    SpeedLimits {
                        horizontalAlignment: HorizontalAlignment.Fill
                    }
//                    StorageSettings {
//                        horizontalAlignment: HorizontalAlignment.Fill
//                        
//                        // This should read from setting.
//                        index: 0
//                        
//                        onIndexChanged: {
//                            console.log("Download to: " + index)
////                            if (index != _app.SETTING) {
////                                _app.SETTING = index;
////                            }
//                        }
//                    }
                }
            }
        },
        SystemToast {
            id: torrentOpenedToast
            body: "Torrent added."
        }
    ] // end of attachedObjects list
}// end of navPane
